# Script saved from Dejal Simon 3.0.1 <http://www.dejal.com/simon/>
# 
# Saved by 松本 光一 on 11/02/19 4:51
# 
# Script is for Python: /usr/bin/python

# *** INSTRUCTIONS: ***
# 
# POP3/SSL サーバが応答を返すかどうか確認します。成功か失敗かが判明するのに少なくとも 90 秒はかかります。 

# *** CUSTOM VARIABLES: ***
# 
# Server name: 
# Server port: 995

# *** CUSTOM RESULTS: ***
# 
# 0: (Success)

# *** SCRIPT: ***

import re
import sys
from subprocess import Popen, PIPE

opensslCmd   = "openssl s_client -connect {Server name}:{Server port}"
patternIMAP = "^\* OK \[CAPABILITY IMAP4rev1"
patternPOP3 = "^\+OK"
patternSMTP = "^220 .+ ESMTP"
quitCmd      = "QUIT\r\n"

def main():

  rcode = 1;

  try:

    imap = re.compile(patternIMAP)
    pop3 = re.compile(patternPOP3)
    smtp = re.compile(patternSMTP)

    p = Popen(args=opensslCmd, shell=True, stdin=PIPE, stdout=PIPE, close_fds=True)

    for line in iter(p.stdout.readline, ""):

      r = pop3.search(line)
      if r:
        rcode = 0
        break
      r = imap.search(line)
      if r:
        break
      r = smtp.search(line)
      if r:
        break
      r = smtp.search(line)
    
    p.stdin.write(quitCmd)
  
  except OSError, err:
    print err.args
  
  sys.exit(rcode)

if __name__ == '__main__':
    main()
